#include "/musr/H/ugens.h"
#include "/musr/H/sfheader.h"
#include <stdio.h>
#include <sys/file.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <math.h>
#include "/musr/macros/delmacros.h"

#define DELARR 28000
#define ARRSIZE 16384
#define SIZE 512

extern SFHEADER      sfdesc[NFILES];

float timepts[100],xvals[100],yvals[100],xpos[512],ypos[512];
int ntimes=0;
float rvbarrayl[10000],rvbarrayr[10000],arr[45000],del[10],amp[10];
int l[2];

double mroom(p,n_args)
float *p;

{
	long nsamps,i,n,count,outbytes,smps=0;
	float val,xin[ARRSIZE*2],out[ARRSIZE*2],xmax,xposit,yposit;
 	float rvbsig,delval,rout,lout,quant=100;
        float reverb();
	int j,k,m,z,lx[2],ly[2],chans,channo=0;
	extern float timepts[],xvals[],yvals[],xpos[],ypos[];	/*for traject*/
	extern int ntimes;				/* also for traject */
	extern int lineset;				/* for curve	*/
	extern float array[SIZE],tabs[2];		/* " " */
	extern struct stat sfst[NFILES];


/* p0-insk; p1-outsk; p2-dur; p3,p4-room dims(+x & +y);
   p5-reverb time, p6-reflectivity, p7-inner rm width, <p8-channel>,
   <p9-quantization>		*/

	if (p[2] == 0)
		p[2] = ((float)(sfst[0].st_size - SIZEOF_BSD_HEADER)
			 /(float)sfclass(&sfdesc[0])/(float)sfchans(&sfdesc[0])
			 /sfsrate(&sfdesc[0])) - p[0];
	if(!lineset) {
		for(j = 0; j < SIZE; j++) array[j] = 1;
		fprintf(stderr,"Set phrase curve to all 1's\n");
		lineset = 1;
		}
        tableset(p[2], SIZE, tabs);

	if (n_args > 8) channo = p[8];
	chans = sfchans(&sfdesc[0]);

        setnote(p[0],p[2],0);
	nsamps = setnote(p[1],p[2],1);

	traject();
	tableset(p[2], 512, lx);
	tableset(p[2], 512, ly);
	ntimes = 0; 		/* to reset curve trajectories	*/

	xmax = 1.0;
   	delset(arr,l,xmax);
  	rvbset(p[5],0,rvbarrayl);
	rvbset(p[5],0,rvbarrayr);

	if (n_args > 9) quant = p[9];
	z = SR/quant;
	j = 0;
        for (i = nsamps; i > 0; i -= ARRSIZE) {
		outbytes = count = (i < ARRSIZE) ? i : ARRSIZE;
		count *= chans;
		bgetin(xin,0,count);
		for (n = channo,k = 0; n < count; n += chans,k += 2) {
			while (!j--) {
				xposit = tablei(smps, xpos, lx);
				yposit = tablei(smps, ypos, ly);
	        		distndelset(xposit,yposit,p[3],p[4],p[7],p[6]);
				val = tablei(smps,array,tabs) * p[3];
				j = z;
				smps += z;
				}
			DELPUT((val*xin[n]),arr,l);
 
			rout = 0.;
			for (m = 1; m < 10; m += 2) {
				DLIGET(arr,del[m],l,delval);
    				rout += delval * amp[m];
    				if (m < 2) rvbsig = -rout;
   				}
  			rvbsig += rout;
			out[k] = rout + reverb(rvbsig,rvbarrayr);

			lout = 0.;
			for (m = 0; m < 10; m += 2) {
				DLIGET(arr,del[m],l,delval);
    				lout += delval * amp[m];
    				if (m < 2) rvbsig = -lout;
   				}
			rvbsig += lout;
		  	out[k+1] = lout + reverb(rvbsig,rvbarrayl);
			}
		baddout(out,1,outbytes*2);
		}

	nsamps = (long) 1*SR;
	for (i = nsamps; i > 0; i -= ARRSIZE) {
		count = (i < ARRSIZE) ? i : ARRSIZE;
		count *= 2;
		for (n = 0; n < count; n += 2) {
			DELPUT(0.,arr,l);
 
			rout = 0.;
			for (m = 1; m < 10; m += 2) {
				DELGET(arr,del[m],l,delval);
    				rout += delval * amp[m];
    				if (m < 2) rvbsig = -rout;
   				}
  			rvbsig += rout;
			out[n] = rout + reverb(rvbsig,rvbarrayr);

			lout = 0.;
			for (m = 0; m < 10; m += 2) {
				DELGET(arr,del[m],l,delval);
    				lout += delval * amp[m];
    				if (m < 2) rvbsig = -lout;
   				}
			rvbsig += lout;
			out[n+1] = lout + reverb(rvbsig,rvbarrayl);
			}
		baddout(out,1,count);
		}
	endnote(1);
}


distndelset(xsource,ysource,xouter,youter,inner,reflect)

float xsource,ysource,xouter,youter,inner,reflect;

{
	double dist[10];
 	int m;


	dist[0]=pow(((double)(xsource-inner)), 2.) + 
		pow(((double)(ysource-1.)), 2.);
	dist[1]=pow(((double)(xsource+inner)),2.) +
		pow(((double)(ysource-1.)),2.);
	dist[2]=pow(((double)(xsource-inner)),2.) +
		pow(((double)(ysource-1. + 2.*(youter-ysource))),2.);
	dist[3]=pow(((double)(xsource+inner)),2.) +
		pow(((double)(ysource-1. + 2.*(youter-ysource))),2.);
	dist[4]=pow((xsource-inner +2.*(xouter-xsource)),2.) +
		pow(((double)(ysource-1.)),2.);
	dist[5]=pow(((double)(xsource+inner +2.*(xouter-xsource))),2.) +
		pow(((double)(ysource-1.)),2.);
	dist[6]=pow(((double)(xsource-inner)),2.) +
		pow(((double)(ysource-1. - 2.*(youter+ysource))),2.);
	dist[7]=pow(((double)(xsource+inner)),2.) +
		pow(((double)(ysource-1. - 2.*(youter+ysource))),2.);
	dist[8]=pow(((double)(xsource-inner - 2.*(xouter+xsource))),2.) +
		pow(((double)(ysource-1.)),2.);
	dist[9]=pow(((double)(xsource+inner - 2.*(xouter+xsource))),2.) +
		pow(((double)(ysource-1.)),2.);

	for (m = 0; m < 10; m++) {
		dist[m] = sqrt(dist[m]);
    		del[m] = (float) (dist[m]/1086.);
    		amp[m] = (float) ((dist[m]-dist[0])/dist[0] * (-6.));
   		amp[m] = (float) (pow(10.,(((double) amp[m])/20.)));
    		if (m > 2) {
      			amp[m] = amp[m] * reflect/100.;
      			}
    		}

   	if (!ysource) {
    		if (xsource < inner)
       			(xsource < -inner ) ? (amp[0]=0.) : (amp[0]=amp[1]=0.);
    		else
       			amp[1] = 0.;
   		}
}

double timeset(p)

float *p;

{
	extern int ntimes;
	extern float timepts[],xvals[],yvals[];

	timepts[ntimes] = p[0];
	xvals[ntimes] = p[1];
	yvals[ntimes] = p[2];
	ntimes++;
}


traject()

{
	float xincr,yincr,scaler;
	int i,n=0,m=0;
	extern float timepts[],xvals[],yvals[],xpos[],ypos[];
	extern int ntimes;

	scaler = 512/timepts[--ntimes];

	for (i = 0; i < ntimes; i++) {
		n += (timepts[i+1] - timepts[i]) * scaler;
		if (n > 511) n = 511;
		xincr = (xvals[i+1] - xvals[i])/(float)(n-m);
		yincr = (yvals[i+1] - yvals[i])/(float)(n-m);
		for (m=m,xpos[m]=xvals[i],ypos[m]=yvals[i]; m<n; m++) {
			xpos[m+1] = xpos[m] + xincr;
			ypos[m+1] = ypos[m] + yincr;
			}
		}

	while (m < 511) {
		xpos[m+1] = xpos[m];
		ypos[m+1] = ypos[m];
		m++;
		}
}
int NBYTES = 32768;
profile()
{
	UG_INTRO("mroom",mroom);
	UG_INTRO("timeset",timeset);
}
